<template>
  <v-card class="my-5">
    <v-card-text>
      <span class="text-overline">Joke #{{ jokeIndex }}</span>
      <p class="text-subtitle-1 font-weight-bold">{{ joke.joke }}</p>
    </v-card-text>

    <v-card-actions>
      <v-spacer/>

      <v-btn icon
             color="primary"
             @click="moveUp"
             :disabled="jokeIndex === 0"
      >
        <v-icon>mdi-chevron-up</v-icon>
      </v-btn>

      <v-btn icon
             color="primary"
             @click="moveDown"
             :disabled="jokeIndex === getCount-1"
      >
        <v-icon>mdi-chevron-down</v-icon>
      </v-btn>

      <v-btn icon
             color="primary"
             @click="deleteJoke"
      >
        <v-icon>mdi-delete</v-icon>
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import {Component, Prop, Vue} from "vue-property-decorator";
import {Joke} from "@/models/joke";
import {mapGetters} from "vuex";

@Component({
  computed: {
    ...mapGetters('joke', {
      getCount: 'getCount',
    }),
  },
})
export default class JokeItem extends Vue {
  @Prop(Joke) readonly joke!: Joke;
  @Prop(Number) readonly jokeIndex!: number;

  moveUp() {
    this.$store.dispatch('joke/moveUp', this.jokeIndex);
  }

  moveDown() {
    this.$store.dispatch('joke/moveDown', this.jokeIndex);
  }

  deleteJoke() {
    this.$store.dispatch('joke/deleteJoke', this.jokeIndex);
  }
}
</script>